unit Outils;

interface

uses
  Windows, Graphics, Clipbrd, SysUtils, ShellApi, Tlhelp32, Registry, DirectX;

function GetCurrentDirectoryPath: String;
function GetSystemDirectoryPath: String;
function TestDirectX6: Boolean;
function DynamicResolution(X, Y: Word): Boolean;
function CopieEcran(X, Y, Width, Height: Integer): TPicture;
function GetRegistration(var User: String): Boolean;

implementation

////////////////////////////////////////////////////////////////////////////////
// Permet de rcuprer le chemin qui donne accs au rpertoire SYSTEM de Windows

function GetSystemDirectoryPath: String;
var
  Dossier: array[0..255] of Char;
begin
  Result:='';
  if GetSystemDirectory(@Dossier, 255)<>0
  then Result:=StrPas(Dossier);
end;

////////////////////////////////////////////////////////////////////////////////
// Permet de connaitre le chemin du rpertoire courant

function GetCurrentDirectoryPath: String;
var
  Dossier: array[0..255] of Char;
begin
  Result:='';
  if GetCurrentDirectory(255, @Dossier)<>0
  then Result:=StrPas(Dossier);
end;

////////////////////////////////////////////////////////////////////////////////
// Teste la prsence de DirectX version 6 minimum
// Ncessite le fichier Dsetup.dll dans le rpertoire courant
// => Faire un recherche sur le dique dur

function TestDirectX6: Boolean;
var
  lpdwVersion: Integer;
  lpdwProduct: Integer;
begin
  Result:=False;
  try
    DirectXSetupGetVersion(lpdwVersion, lpdwProduct);
    if Lo(lpdwVersion)>=6 then Result:=True;
  except
    Result:=False;
  end;
end;


////////////////////////////////////////////////////////////////////////////////
// Change dynamiquement la rsolution d'affichage
// if DynamicResolution(Nouveau X, Nouveau Y) then ...

function DynamicResolution(X, Y: Word): Boolean;
var
  lpDevMode: TDeviceMode;
begin
  Result:=EnumDisplaySettings(nil, 0, lpDevMode);
  if Result then begin
    lpDevMode.dmFields:=dm_PelsWidth or dm_PelsHeight;
    lpDevMode.dmPelsWidth:=X;
    lpDevMode.dmPelsHeight:=Y;
    Result:=ChangeDisplaySettings(lpDevMode,0)=Disp_Change_Successful;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
// Copie d'cran dans un Bitmap.
// X,Y : coordoones en haut  gauche

function CopieEcran(X, Y, Width, Height: Integer): TPicture;
var
  ImageBureau: TPicture;
begin
  ImageBureau:=TPicture.Create;
  ImageBureau.Bitmap.Width:=Width;
  ImageBureau.Bitmap.Height:=Height;
  BitBlt(
    ImageBureau.Bitmap.Canvas.Handle,
    -X,
    -Y,
    Width+X,
    Height+Y,
    GetDC(GetDesktopWindow),
    0,
    0,
    SrcCopy
    );
  Result:=ImageBureau;
end;

////////////////////////////////////////////////////////////////////////////////
// Teste l'enregistrement de lit&ratique.

function GetRegistration(var User: String): Boolean;
var
  Registre: TRegistry;
begin
  Result:=False;
  Registre:=TRegistry.Create;
  with Registre do               {On rcupre l'info depuis la base de registre}
  try
    RootKey:=HKEY_CURRENT_USER;
    if OpenKey('\SOFTWARE\Entropie\User',False) then Result:=True;
    User:=ReadString('User');
  finally
    Free;
  end;
end;


end.
